﻿XIncludeFile "include\OnErrorHandler.pbi"
XIncludeFile "include\SecureSendData.pbi"
XIncludeFile "include\ConvenientMathMacros.pbi"
XIncludeFile "CollisionAPI.pbi"
XIncludeFile "include\SpriteBackfaceCulling.pbi"
XIncludeFile "include\SinglePrecisionFloat.pbi"
XIncludeFile "include\IndexedFile.pbi"
XIncludeFile "include\SpriteFromImage.pbi"


Global NewMap Index.FileEntry()

If CountProgramParameters() = 0
  MessageRequester("Error", "No parameters parsed.")
  End
EndIf

For a = 0 To CountProgramParameters()-1
  s$ = ProgramParameter(a)
  Debug s$
  Select LCase(Left(s$, 3))
    Case "cd:"
      SetCurrentDirectory(Mid(s$, 4))
    Case "ld:"
      curdir$ = GetCurrentDirectory()
      SetCurrentDirectory(Mid(s$, 4))
      CreateIndex(Index(), "", 16)
      SetCurrentDirectory(curdir$)
    Case "ldnz:"
      curdir$ = GetCurrentDirectory()
      SetCurrentDirectory(Mid(s$, 4))
      CreateIndex(Index(), "", 0)
      SetCurrentDirectory(curdir$)
  EndSelect
Next


Procedure Init()
  InitSprite()
  InitSound()
  InitKeyboard()
  InitNetwork()
  
  UsePNGImageDecoder()
  UseOGGSoundDecoder()
  
  ToggleSinglePrecisionFloat(1)
  
  LoadIndexedSound(Index(), 1, "sounds\music\turmoil_short.ogg", #PB_Sound_Streaming)
  LoadIndexedSound(Index(), 2, "sounds\click.wav")
  LoadIndexedSound(Index(), 3, "sounds\launch.wav")
  LoadIndexedSound(Index(), 4, "sounds\hit.wav")
  
  
  LoadIndexedImage(Index(), 1, "textures\player\collision.png")
  LoadIndexedImage(Index(), 2, "maps\testlevel\collision.png")
  LoadIndexedImage(Index(), 3, "maps\testlevel\color.png")
  LoadIndexedImage(Index(), 4, "textures\player\stand.png")
  LoadIndexedImage(Index(), 5, "textures\player\walk.png")
  LoadIndexedImage(Index(), 6, "textures\player\jump.png")
  LoadIndexedImage(Index(), 7, "textures\player\run.png")
  LoadIndexedImage(Index(), 8, "textures\orb.png")
  CreateImage(9, 1, 1, 32)
  
EndProcedure

Procedure ResizeScreen(Window.l, WinSizeStep.l, ZoomFactor.l)
  Static firstrun.l
  Static LastX.l
  Static LastY.l
  Protected X.l
  Protected Y.l
  X = WindowWidth(0)-WindowWidth(0)%(WinSizeStep*2)
  Y = WindowHeight(0)-WindowHeight(0)%(WinSizeStep*2)
  Debug X
  Debug Y
  If X <> LastX Or Y <> LastY
    LastX = X
    LastY = Y
    ResizeWindow(Window, #PB_Ignore, #PB_Ignore, X, Y)
  EndIf
  
  ;OpenWindowedScreen(WindowID(Window), WindowWidth(0)%(WinSizeStep*2)/2, WindowHeight(0)%(WinSizeStep*2), X/ZoomFactor, Y/ZoomFactor, 1, WindowWidth(0)%(WinSizeStep*2)/2, WindowHeight(0)%(WinSizeStep*2)/2, #PB_Screen_SmartSynchronization)
  OpenWindowedScreen(WindowID(Window), 0, 0, X/ZoomFactor, Y/ZoomFactor, 1, 0, 0, #PB_Screen_SmartSynchronization)
  SpriteQuality(0)
  ToggleSpriteBackfaceCulling(0)
  
  
  TransparentSpriteColor(#PB_Default, $FF00FF)
  SpriteFromImage(1, 1, #PB_Sprite_AlphaBlending)
  SpriteFromImage(2, 2, #PB_Sprite_AlphaBlending)
  SpriteFromImage(3, 3, #PB_Sprite_AlphaBlending)
  SpriteFromImage(4, 4, #PB_Sprite_AlphaBlending)
  SpriteFromImage(5, 5, #PB_Sprite_AlphaBlending)
  SpriteFromImage(6, 6, #PB_Sprite_AlphaBlending)
  SpriteFromImage(7, 7, #PB_Sprite_AlphaBlending)
  SpriteFromImage(8, 8, #PB_Sprite_AlphaBlending)
  SpriteFromImage(9, 9, #PB_Sprite_AlphaBlending)
EndProcedure




Init()
zoomfactor = 4
sharpdisplay = 1
OpenWindow(0,
           #PB_Ignore, #PB_Ignore,
           800, 600,
           "Awoo! b"+#PB_Editor_CompileCount+", v"+#pb_editor_BuildCount,
           #PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_SizeGadget|#PB_Window_BorderLess)
WindowBounds(0, 1, 1, #PB_Ignore, #PB_Ignore)
SetWindowColor(0, $000000)
CreatePopupMenu(0)

OpenSubMenu("Display")
MenuItem(1, "Stretch"+Chr(9)+"F1")
MenuItem(2, "Outline"+Chr(9)+"F2")
MenuItem(4, "Sharpdisplay"+Chr(9)+"F4")
MenuItem(6, "Zoom -"+Chr(9)+"F6")
MenuItem(7, "Zoom +"+Chr(9)+"F7")
MenuItem(12, "Toggle Fullscreen"+Chr(9)+"F12")
CloseSubMenu()

OpenSubMenu("Game")
MenuItem(9, "Kill"+Chr(9)+"F9")
CloseSubMenu()

MenuBar()
MenuItem(0, "Exit")

ResizeScreen(0, zoomfactor, zoomfactor*Bool(Not sharpdisplay)+Bool(sharpdisplay))

World.Entity2D
StartDrawing(ImageOutput(2))
DrawingMode(#PB_2DDrawing_AllChannels)
Dim World\Phys\datCollision(OutputWidth()-1, OutputHeight()-1)
For b = 0 To OutputHeight()-1
  For a = 0 To OutputWidth()-1
    If Point(a, b) <> $00000000
      World\Phys\datCollision(a, b) = 1
    EndIf
  Next
Next
StopDrawing()
World\Phys\posPosition\X = 0
World\Phys\posPosition\Y = 0
World\Phys\posVelocity\X = 0
World\Phys\posVelocity\Y = 0
PlayerStart.Entity2D
StartDrawing(ImageOutput(1))
DrawingMode(#PB_2DDrawing_AllChannels)
Dim PlayerStart\Phys\datCollision(OutputWidth()-1, OutputHeight()-1)
For b = 0 To OutputHeight()-1
  For a = 0 To OutputWidth()-1
    c = Point(a, b)
    If c <> $00000000
      PlayerStart\Phys\datCollision(a, b) = 1
    EndIf
  Next
Next
StopDrawing()

PlayerStart\Phys\posPosition\X = 0
PlayerStart\Phys\posPosition\Y = 100
PlayerStart\Phys\posVelocity\X = 3
PlayerStart\Phys\posVelocity\Y = -2
PlayerStart\Phys\parElasticity\X = 1.0
PlayerStart\Phys\parElasticity\Y = 0.0

Player.Entity2D
CopyMemory(@PlayerStart, @Player, SizeOf(Entity2D))

NewList Particle.Entity2D()

#orbcount = 10
NewList Orb.Entity2D()

For oi = 0 To #orbcount-1
  AddElement(Orb())
  Dim Orb()\Phys\datCollision(SpriteHeight(8)-1, SpriteHeight(8)-1)
  For b = 0 To ArraySize(Orb()\Phys\datCollision(), 2)
    For a = 0 To ArraySize(Orb()\Phys\datCollision(), 1)
      Orb()\Phys\datCollision(a, b) = 1
    Next
  Next
  Orb()\Phys\posPosition\X = 0
  Orb()\Phys\posPosition\Y = 100
  Orb()\Phys\posVelocity\X = 0
  Orb()\Phys\posVelocity\Y = 0
  Orb()\Phys\parElasticity\X = 0.2
  Orb()\Phys\parElasticity\Y = 0.2
  Orb()\Phys\parWeight\X = 0.001
  Orb()\Phys\parWeight\Y = 0.001
Next

Ghost.Entity2D

e.f
PlaySound(1, #PB_Sound_Loop, 20)
lookat = 1
ReleasedJump = 1
Repeat
  Repeat
    event = WindowEvent()
    Select event
      Case #PB_Event_CloseWindow
        End
      Case #PB_Event_RestoreWindow
        If isfullscreen = 1 
          SetWindowLong_(WindowID(0),#GWL_STYLE,GetWindowLong_(WindowID(0),#GWL_STYLE)|#WS_BORDER)
          isfullscreen = 0
        EndIf
      Case #PB_Event_MaximizeWindow
        
      Case #PB_Event_SizeWindow
        ResizeScreen(0, zoomfactor, zoomfactor*Bool(Not sharpdisplay)+Bool(sharpdisplay))
      Case #WM_LBUTTONDOWN
        SendMessage_(WindowID(0), #WM_NCLBUTTONDOWN, #HTCAPTION, 0)
        
      Case #PB_Event_Menu
        Select EventMenu()
          Case 0
            PostEvent(#PB_Event_CloseWindow)
          Case 1
            stretchsquish = Bool(stretchsquish = 0)
          Case 2
            outline = Bool(outline = 0)
          Case 4
            sharpdisplay = Bool(sharpdisplay = 0)
            ;PostEvent(#PB_Event_SizeWindow)
            ResizeScreen(0, zoomfactor, zoomfactor*Bool(Not sharpdisplay)+Bool(sharpdisplay))
          Case 6
            If zoomfactor > 1
              zoomfactor-1
              PostEvent(#PB_Event_SizeWindow)
            EndIf
          Case 7
            If zoomfactor < 16
              zoomfactor+1
              PostEvent(#PB_Event_SizeWindow)
            EndIf
          Case 9
            PlaySound(4)
            StartDrawing(ImageOutput(psprite))
            DrawingMode(#PB_2DDrawing_AllChannels)
            Debug OutputHeight()
            Debug OutputWidth()
            Debug currentframe
            
            For b = 0 To OutputHeight()-1
              For a = 0 To OutputHeight()-1
                
                c = Point(a+currentframe*OutputHeight(), b)
                If c <> $00000000
                  AddElement(Particle())
                  Dim Particle()\Phys\datCollision(0, 0)
                  Particle()\Phys\datCollision(0, 0) = 1
                  Particle()\GraphicsSprite = RGB(Red(c), Green(c), Blue(c))
                  Particle()\Phys\parElasticity\X = 0.5
                  Particle()\Phys\parElasticity\Y = 0.2
                  Select lookat
                    Case 1
                      Particle()\Phys\posPosition\X = Player\Phys\posPosition\X-OutputHeight()/2+a
                    Case -1
                      Particle()\Phys\posPosition\X = Player\Phys\posPosition\X+OutputHeight()/2-a
                  EndSelect
                  
                  Particle()\Phys\posPosition\Y = Player\Phys\posPosition\Y-OutputHeight()/2+b
                  Particle()\Phys\posVelocity\X = Player\Phys\posVelocity\X/2-0;+(Random(100)-50)/1000
                  Particle()\Phys\posVelocity\Y = Player\Phys\posVelocity\Y/2-0;+(Random(100)-50)/1000;-2
                EndIf
              Next
            Next
            StopDrawing()
            CopyMemory(@PlayerStart, @Player, SizeOf(Entity2D))
            
          Case 12
            Select isfullscreen
              Case 0
                SetWindowLong_(WindowID(0),#GWL_STYLE,GetWindowLong_(WindowID(0),#GWL_STYLE)& ~#WS_BORDER)
                SetWindowState(0, #PB_Window_Maximize)
                isfullscreen = 1
              Case 1
                SetWindowLong_(WindowID(0),#GWL_STYLE,GetWindowLong_(WindowID(0),#GWL_STYLE)|#WS_BORDER)
                SetWindowState(0, #PB_Window_Normal)
                isfullscreen = 0
            EndSelect
          Case 14
            DisplayPopupMenu(0, WindowID(0), WindowX(0, #PB_Window_InnerCoordinate), WindowY(0, #PB_Window_InnerCoordinate))
        EndSelect
    EndSelect
  Until Not event
  ExamineKeyboard()
  
  If KeyboardReleased(#PB_Key_0)
    cheatstring$+"0"
  EndIf
  If KeyboardReleased(#PB_Key_1)
    cheatstring$+"1"
  EndIf
  If KeyboardReleased(#PB_Key_2)
    cheatstring$+"2"
  EndIf
  If KeyboardReleased(#PB_Key_3)
    cheatstring$+"3"
  EndIf
  If KeyboardReleased(#PB_Key_4)
    cheatstring$+"4"
  EndIf
  If KeyboardReleased(#PB_Key_5)
    cheatstring$+"5"
  EndIf
  If KeyboardReleased(#PB_Key_6)
    cheatstring$+"6"
  EndIf
  If KeyboardReleased(#PB_Key_7)
    cheatstring$+"7"
  EndIf
  If KeyboardReleased(#PB_Key_8)
    cheatstring$+"8"
  EndIf
  If KeyboardReleased(#PB_Key_9)
    cheatstring$+"9"
  EndIf
  If Len(cheatstring$) > 4
    cheatstring$ = Right(cheatstring$, 4)
  EndIf
  
  If cheatstring$ = "1234";"68595958185741527096"
    PostEvent(#PB_Event_Menu, 0, 14)
    cheatstring$ = ""
  EndIf
  
  If KeyboardReleased(#PB_Key_Escape)
    PostEvent(#PB_Event_Menu, 0, 14)
  EndIf
  
  If KeyboardReleased(#PB_Key_F1)
    PostEvent(#PB_Event_Menu, 0, 1)
  EndIf
  If KeyboardReleased(#PB_Key_F2)
    PostEvent(#PB_Event_Menu, 0, 2)
  EndIf
  
  If KeyboardReleased(#PB_Key_F4)
    PostEvent(#PB_Event_Menu, 0, 4)
  EndIf
  
  If KeyboardReleased(#PB_Key_F6)
    PostEvent(#PB_Event_Menu, 0, 6)
  EndIf
  If KeyboardReleased(#PB_Key_F7)
    PostEvent(#PB_Event_Menu, 0, 7)
  EndIf
  
  If KeyboardReleased(#PB_Key_F9)
    PostEvent(#PB_Event_Menu, 0, 9)
  EndIf
  
  If KeyboardReleased(#PB_Key_F12)
    PostEvent(#PB_Event_Menu, 0, 12)
  EndIf
  
  
  
  sprint = Bool(KeyboardPushed(#PB_Key_LeftShift))
  If Player\Phys\retCollision\Y = 1
    MidAir = 0
  EndIf
  
  If KeyboardPushed(#PB_Key_Space) And ReleasedJump = 1
    ShallJump = 1  
    ReleasedJump = 0
  EndIf
  If KeyboardReleased(#PB_Key_Space)
    ReleasedJump = 1
    ShallJump = 0
  EndIf
  
  If Player\Phys\retCollision\Y = 1
    MidAir = 0
    EnableDoubleJump = 0
  Else
    MidAir = 1
  EndIf
  
  If ShallJump = 1
    Select EnableDoubleJump
      Case 1
        Player\Phys\posVelocity\Y=-3.2;4.5
        EnableDoubleJump = 0
        ShallJump = 0
        PlaySound(2)
      Case 0
        If MidAir = 0
          EnableDoubleJump = 1
          ShallJump = 0
          Player\Phys\posVelocity\Y=-3.2;4.5
          Player\Phys\posVelocity\X*2
          PlaySound(2)
        EndIf
    EndSelect
  EndIf
  
  
  If KeyboardPushed(#PB_Key_A)
    Player\Phys\posVelocity\X-0.085*(1+Bool(sprint <> 0))+0.02*Bool(lookat = 1)*(1+Bool(sprint <> 0))
  EndIf
  
  If KeyboardPushed(#PB_Key_D)
    Player\Phys\posVelocity\X+0.085*(1+Bool(sprint <> 0))-0.02*Bool(lookat = -1)*(1+Bool(sprint <> 0))
  EndIf
  
  
  If KeyboardPushed(#PB_Key_S) And sprinted <= 0
    sprinted = 75
    Player\Phys\posVelocity\X+6*lookat
    If Player\Phys\posVelocity\Y > -1
      Player\Phys\posVelocity\Y=-1
    EndIf
    PlaySound(3)
  EndIf
  If sprinted > 0
    sprinted-1
  EndIf
  
  If KeyboardPushed(#PB_Key_Tab)
    Player\Phys\posVelocity\X*1.09
  EndIf
  
  If KeyboardPushed(#PB_Key_Up)
    Player\Phys\posPosition\Y-1
  EndIf
  If KeyboardPushed(#PB_Key_Left)
    Player\Phys\posPosition\X-1
  EndIf
  If KeyboardPushed(#PB_Key_Right)
    Player\Phys\posPosition\X+1
  EndIf
  If KeyboardPushed(#PB_Key_Down)
    Player\Phys\posPosition\Y+1
  EndIf
  
  
  
  Player\Phys\posVelocity\Y+0.2
  Player\Phys\posVelocity\X*0.92
  
  If Abs(Player\Phys\posVelocity\X) < 0.02
    Player\Phys\posVelocity\X = 0
  EndIf
  
  
  
  
  
  
  MovePhys2D(@Player\Phys, @World\Phys)
  
  DisplayTransparentSprite(3, World\Phys\posPosition\X-Player\Phys\posPosition\X+ScreenWidth()/2-SpriteWidth(3)/2, World\Phys\posPosition\Y-Player\Phys\posPosition\Y+ScreenHeight()/2-SpriteHeight(3)/2)
  DisplayTransparentSprite(2, World\Phys\posPosition\X-Player\Phys\posPosition\X+ScreenWidth()/2-SpriteWidth(2)/2, World\Phys\posPosition\Y-Player\Phys\posPosition\Y+ScreenHeight()/2-SpriteHeight(2)/2)
  
   ForEach Particle()
     If Particle()\Phys\retCollision\Y = 1 And Particle()\Phys\posVelocity\Y >= -0.02
       DeleteElement(Particle())
     Else
       Particle()\Phys\posVelocity\Y+0.1
       FastMovePhys2D(@Particle()\Phys, @World\Phys)
       DisplayTransparentSprite(9, Particle()\Phys\posPosition\X-Player\Phys\posPosition\X+ScreenWidth()/2-1, Particle()\Phys\posPosition\Y-Player\Phys\posPosition\Y+ScreenHeight()/2-1, 255, Particle()\GraphicsSprite)
     EndIf
   Next
   
  ForEach Orb()
    
    If Orb()\Phys\posPosition\X < Player\Phys\posPosition\X
      Orb()\Phys\posVelocity\X+0.01*Random(3, 0)
    EndIf
    If Orb()\Phys\posPosition\X > Player\Phys\posPosition\X
      Orb()\Phys\posVelocity\X-0.01*Random(3, 0)
    EndIf
    If Orb()\Phys\posPosition\Y < Player\Phys\posPosition\Y
      Orb()\Phys\posVelocity\Y+0.01*Random(3, 0)
    EndIf
    If Orb()\Phys\posPosition\Y > Player\Phys\posPosition\Y
      Orb()\Phys\posVelocity\Y-0.01*Random(3, 0)
    EndIf
    CopyMemory(@Orb(), @Ghost, SizeOf(Entity2D))
    MovePhys2D(@Orb()\Phys, @World\Phys)
    MovePhys2D(@Ghost\Phys, @Player\Phys, 1)
    ;MovePhys2D(@Orb(oi)\Phys, @Player\Phys)
    DisplayTransparentSprite(8, Orb()\Phys\posPosition\X-Player\Phys\posPosition\X+ScreenWidth()/2-SpriteWidth(8)/2, Orb()\Phys\posPosition\Y-Player\Phys\posPosition\Y+ScreenHeight()/2-SpriteHeight(8)/2)
  Next
  
  If Player\Phys\retCollision\Y <> 0
    Player\Phys\posPosition\Y = Round(Player\Phys\posPosition\Y, #PB_Round_Nearest)
  EndIf
  If Player\Phys\retCollision\X <> 0
    Player\Phys\posPosition\X = Round(Player\Phys\posPosition\X, #PB_Round_Nearest)
  EndIf
  
  
  If KeyboardPushed(#PB_Key_J)
    lookat = -1
  EndIf
  If KeyboardPushed(#PB_Key_L)
    lookat = 1
  EndIf
  
  
  If Abs(Player\Phys\posVelocity\X) > 1.7
    psprite = 7
  ElseIf Abs(Player\Phys\posVelocity\X) > 0.1
    psprite = 5
  Else
    psprite = 4
  EndIf
  If Player\Phys\retCollision\y <> 1
    psprite = 6
  EndIf
  
  
  ClipSprite(psprite, #PB_Default, #PB_Default, #PB_Default, #PB_Default) 
  If e >= (SpriteWidth(psprite)/SpriteHeight(psprite))*6
    e = 0
  EndIf
  If e <= -1
    e = (SpriteWidth(psprite)/SpriteHeight(psprite))*6-1
  EndIf
  
  currentframe = Int(e)/6
  ClipSprite(psprite, (Int(e)/6)*SpriteHeight(psprite), 0, SpriteHeight(psprite), SpriteHeight(psprite))
  xmu.f + Player\Phys\posVelocity\X/5
  xml.f = 0
  
  ymu.f - Player\Phys\posVelocity\Y/4
  yml.f = 0
  
  xmu*0.9
  xml*0.9
  
  ymu*0.8
  yml*0.8
  
  If stretchsquish = 1
    yml = 0
    ymu = 0
    xml = 0
    xmu = 0
  EndIf
  
  Select lookat
    Case -1
      TransformSprite(psprite, 32+xmu, 0+ymu, 0+xmu, 0+ymu, 0+xml, 32+yml, 32+xml, 32+yml)
    Case 1
      TransformSprite(psprite, 0+xmu, 0+ymu, 32+xmu, 0+ymu, 32+xml, 32+yml, 0+xml, 32+yml)
  EndSelect
  If outline = 1
    For g = -1 To 1
      DisplayTransparentSprite(psprite, Player\Phys\posPosition\X-Player\Phys\posPosition\X+ScreenWidth()/2-SpriteHeight(psprite)/2+g, Player\Phys\posPosition\Y-Player\Phys\posPosition\Y+ScreenHeight()/2-SpriteHeight(psprite)/2-1, 255, $000000)
      DisplayTransparentSprite(psprite, Player\Phys\posPosition\X-Player\Phys\posPosition\X+ScreenWidth()/2-SpriteHeight(psprite)/2+g, Player\Phys\posPosition\Y-Player\Phys\posPosition\Y+ScreenHeight()/2-SpriteHeight(psprite)/2  , 255, $000000)
      DisplayTransparentSprite(psprite, Player\Phys\posPosition\X-Player\Phys\posPosition\X+ScreenWidth()/2-SpriteHeight(psprite)/2+g, Player\Phys\posPosition\Y-Player\Phys\posPosition\Y+ScreenHeight()/2-SpriteHeight(psprite)/2+1, 255, $000000)
    Next
  EndIf
  
  
  ;SpriteQuality(1)
  DisplayTransparentSprite(psprite, Player\Phys\posPosition\X-Player\Phys\posPosition\X+ScreenWidth()/2-SpriteHeight(psprite)/2, Player\Phys\posPosition\Y-Player\Phys\posPosition\Y+ScreenHeight()/2-SpriteHeight(psprite)/2)
  
  
  If Player\Phys\retCollision\Y = 1 And Abs(Player\Phys\posVelocity\X) >= 0.1
    e+(Player\Phys\posVelocity\X*1.3)*Sign(lookat)
  Else
    e+1;Sign(lookat)
  EndIf
  
  
  
  If sharpdisplay = 1
    SpriteQuality(0)
    GrabSprite(10, ScreenWidth()/2-ScreenWidth()/(zoomfactor*2), ScreenHeight()/2-ScreenHeight()/(zoomfactor*2), ScreenWidth()/(zoomfactor), ScreenHeight()/(zoomfactor))
    ZoomSprite(10, ScreenWidth(), ScreenHeight())
    DisplaySprite(10, 0, 0)
    ZoomSprite(10, #PB_Default, #PB_Default)
    
  EndIf
  
  ;StartDrawing(ScreenOutput())
  ;DrawText(1, 0, Str(Player\Phys\retCollision\Y), $000000, $FFFFFF)
  ;DrawText(1, 20, StrF(Player\Phys\posVelocity\X), $000000, $FFFFFF)
  ;DrawText(1, 40, StrF(Player\Phys\posVelocity\Y), $000000, $FFFFFF)
  ;DrawText(1, 60, StrF(Player\Phys\posPosition\X), $000000, $FFFFFF)
  ;DrawText(1, 80, StrF(Player\Phys\posPosition\Y), $000000, $FFFFFF)
  ;StopDrawing()
  
  FlipBuffers()
  ClearScreen($dddddd)
ForEver


; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 167
; FirstLine = 161
; Folding = -
; Executable = ..\main.exe
; CPU = 5
; DisableDebugger
; CurrentDirectory = ..\
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant