﻿;ArrayCollision is an "efficient" replacement for SpritePixelCollision.
;Reasoning behind this:
;-Loading/Creating a sprite with #PB_Sprite_PixelCollision significantly slows displaying it.
;-SpritePixelCollision() is extremely slow with huge sprites, probably due to memory operations.
;-ClipSprite() doesn't reduce the load, but rather squashes the collision information into the new rectangle.

;There shall be no credit.

XIncludeFile "include\ConvenientMathMacros.pbi"

Procedure ArrayCollision2D(Array Object1.a(2), X1.l, Y1.l, Array Object2.a(2), X2.l, Y2.l)
  Protected A.l
  Protected B.l
  Protected X.l
  Protected Y.l
  Protected W1.l = ArraySize(Object1(), 1)
  Protected H1.l = ArraySize(Object1(), 2)
  Protected W2.l = ArraySize(Object2(), 1)
  Protected H2.l = ArraySize(Object2(), 2)
  X1-W1/2
  Y1-H1/2
  X2-W2/2
  Y2-H2/2
  For B = 0 To H1
    Y = B+(Y1-Y2)
    If Not InRangeL(Y, 0, H2)
      Continue
    EndIf
    For A = 0 To W1
      X = A+(X1-X2)
      If Not InRangeL(X, 0, W2)
        Continue
      EndIf
      
      
      If Object1(A, B) <> 0
        Select Object2(X, Y)
            Case 1
              ProcedureReturn 1
            Default
          EndSelect
      EndIf
    Next
  Next
  ProcedureReturn 0
EndProcedure

; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 4
; Folding = -
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant