﻿;Some Math macros to ease development.

;There shall be no credit.

Macro SinD(Value) ;Calculates trigonometric functions from degrees, or returns degrees.
  Sin(Radian(Value)) ;For those of us who always forget the oh so lovely Radian in their Sin(), Cos(), and Tan() operations.
EndMacro
Macro CosD(Value)
  Cos(Radian(Value))
EndMacro
Macro TanD(Value)
  Tan(Radian(Value))
EndMacro

Macro ASinD(Value)
  Degree(ATan(Value))
EndMacro
Macro ACosD(Value)
  Degree(ATan(Value))
EndMacro
Macro ATanD(Value)
  Degree(ATan(Value))
EndMacro


Macro Fraction(Value) ;Returns the fraction of a float.
  (Value-Int(Value))
EndMacro


Procedure.l AbsL(Value.l)
  If Value < 0
    Value = -Value
  EndIf
  ProcedureReturn Value
EndProcedure
Procedure.f AbsF(Value.f)
  If Value < 0
    Value = -Value
  EndIf
  ProcedureReturn Value
EndProcedure


Macro InRangeM(Value, Min, Max) ;Returns 1 if Value is between Min and Max.
  (Bool(Value >= Min)&Bool(Value <= Max))
EndMacro
Procedure.l InRangeL(Value.l, Min.l, Max.l) ;Returns 1 if Value is between Min and Max.
  If Value >= Min And Value <= Max
    ProcedureReturn 1
  EndIf
  ProcedureReturn 0
EndProcedure
Procedure.f InRangeF(Value.f, Min.f, Max.f) ;Returns 1 if Value is between Min and Max.
  If Value >= Min And Value <= Max
    ProcedureReturn 1
  EndIf
  ProcedureReturn 0
EndProcedure

Macro KeepInRangeM(Value, Min, Max) ;Returns a capped value.
  (Bool(Value >= Min)&Bool(Value <= Max))*Value+Bool(Value < Min)*Min+Bool(Value > Max)*Max
EndMacro
Procedure.l KeepInRangeL(Value.l, Min.l, Max.l) ;Returns a capped value.
  If InRangeL(Value, Min, Max)
    ProcedureReturn Value
  ElseIf Value > Max
    ProcedureReturn Max
  Else
    ProcedureReturn Min
  EndIf
EndProcedure
Procedure.f KeepInRangeF(Value.f, Min.f, Max.f) ;Returns a capped value.
  If InRangeF(Value, Min, Max)
    ProcedureReturn Value
  ElseIf Value > Max
    ProcedureReturn Max
  Else
    ProcedureReturn Min
  EndIf
EndProcedure

Procedure.l RollInRangeL(Value.l, Min.l, Max.l)
  Distance.l = AbsL(Max-Min)
  While Value > Max
    Value = Value-Distance-1
  Wend
  While Value < Min
    Value = Value+Distance+1
  Wend
  ProcedureReturn Value
EndProcedure
Procedure.f RollInRangeF(Value.f, Min.f, Max.f)
  Distance.l = Abs(Max-Min)
  While Value > Max
    Value = Value-Distance-1
  Wend
  While Value < Min
    Value = Value+Distance+1
  Wend
  ProcedureReturn Value
EndProcedure


Procedure.l Max2L(Value1.l, Value2.l) ;Returns the biggest of 2 values.
  If Value2 > Value1
    Swap Value2, Value1
  EndIf
  ProcedureReturn Value1    
EndProcedure
Procedure.f Max2F(Value1.f, Value2.f) ;Returns the biggest of 2 values.
  If Value2 > Value1
    Swap Value2, Value1
  EndIf
  ProcedureReturn Value1    
EndProcedure


Procedure.l Max3L(Value1.l, Value2.l, Value3.l) ;Returns the biggest of 3 values.
  If Value2 > Value1
    Swap Value2, Value1
  EndIf
  If Value3 > Value1
    Swap Value3, Value1
  EndIf
  ProcedureReturn Value1
EndProcedure
Procedure.f Max3F(Value1.f, Value2.f, Value3.f) ;Returns the biggest of 3 values.
  If Value2 > Value1
    Swap Value2, Value1
  EndIf
  If Value3 > Value1
    Swap Value3, Value1
  EndIf
  ProcedureReturn Value1    
EndProcedure



Macro DifferenceL(Value1, Value2) ;Returns the absolute difference of 2 values.
  AbsL(Value1-Value2)
EndMacro
Macro DifferenceF(Value1, Value2) ;Returns the absolute difference of 2 values.
  Abs(Value1-Value2)
EndMacro



; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 138
; FirstLine = 125
; Folding = ----