﻿Structure ReceiveNetworkBlock
  Length.l
  Shift.l
  *Memory
  CurrentLength.l
EndStructure

Procedure.l SecureSendData(ConnectionID.l, *DataToSend, DataLength.l, NullTerminationLength.l = 0)
  
  Protected CurrentLength.l, Result.l
  Protected HeaderLength.l = SizeOf(Long)
  Protected BlockLength.l = DataLength+NullTerminationLength
  Protected *Buffer = AllocateMemory(HeaderLength+BlockLength)
  
  PokeL(*Buffer, BlockLength)
  CopyMemory(*DataToSend, *Buffer+HeaderLength, DataLength)
  
  Repeat
    Result = SendNetworkData(ConnectionID, *Buffer+CurrentLength, HeaderLength+BlockLength-CurrentLength)
    If Result > 0
      CurrentLength + Result
    EndIf
  Until CurrentLength = HeaderLength+BlockLength
  FreeMemory(*Buffer)
  
  ProcedureReturn CurrentLength
  
EndProcedure

Procedure.l SecureReceiveData(ConnectionID.i)
  
  Static NewMap Connection.ReceiveNetworkBlock()
  Protected *Connection.ReceiveNetworkBlock
  Protected *Pointer
  Protected Key.s = Str(ConnectionID)
  Protected ReceiveLength.l, Length.l

  If FindMapElement(Connection(), Key)
    *Connection = Connection()
  Else
    *Connection = AddMapElement(Connection(), Key)
  EndIf
  If *Connection\Memory = #Null
    
    ReceiveLength = ReceiveNetworkData(ConnectionID, @*Connection\Length+*Connection\Shift, SizeOf(Long)-*Connection\Shift)
    If ReceiveLength > 0
      If ReceiveLength+*Connection\Shift = SizeOf(Long)
        *Connection\Memory = AllocateMemory(*Connection\Length+1)
      Else
        *Connection\Shift + ReceiveLength
      EndIf
    EndIf
  Else
    
    Length = *Connection\Length - *Connection\CurrentLength
    ReceiveLength = ReceiveNetworkData(ConnectionID, *Connection\Memory+*Connection\CurrentLength, Length)
    If ReceiveLength = Length
      *Pointer = *Connection\Memory
      DeleteMapElement(Connection(), Key)
    ElseIf ReceiveLength > 0
      *Connection\CurrentLength + ReceiveLength
    EndIf
  EndIf
  
  ProcedureReturn *Pointer
  
EndProcedure

Procedure.l SecureSendString(ConnectionID.l, String.s)
  ProcedureReturn SecureSendData(ConnectionID, @String, MemoryStringLength(@String, #PB_Ascii), 1)
EndProcedure
Procedure.s SecureReceiveString(ConnectionID.l)
  Protected *Pointer
  Protected String.s
  *Pointer = SecureReceiveData(ConnectionID)
  If *Pointer <> 0
    String = PeekS(*Pointer)
    FreeMemory(*Pointer)
    ProcedureReturn String
  EndIf
EndProcedure
CompilerIf #PB_Compiler_Version > 500
CompilerIf #PB_Compiler_IsMainFile
InitNetwork()

CreateNetworkServer(1, 7000, #PB_Network_TCP, "127.0.0.1")
Define CID = OpenNetworkConnection("127.0.0.1", 7000, #PB_Network_TCP)
Define String.s
#iteration = 1

For e = 0 To #iteration-1
  SecureSendString(CID, "Hallo Welt")
  Delay(100)
  SecureSendString(CID, "Ende!")
Next


Debug "________"
Repeat
  Select NetworkServerEvent()
    Case #PB_NetworkEvent_Data
      String = SecureReceiveString(EventClient())
      If String 
        Debug Str(Len(String))+" : "+String
        indx+1
      EndIf
    Default
      Delay(10)
  EndSelect
ForEver
MessageRequester("", Str(indx))
CompilerEndIf
CompilerEndIf
; IDE Options = PureBasic 5.00 (Windows - x86)
; CursorPosition = 112
; FirstLine = 91
; Folding = --
; Executable = net_exe.exe
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant