﻿;This patch will reduce float precision for more speed.
;Sin/Cos are not affected.
;Generally, there will be a 1/3 speed boost on an Intel Atom Z3775:

;Credit goes to "Helle" Klaus Helbing (http://www.purebasicr/english/viewtopic.php?f=12&t=25242)
Procedure ToggleSinglePrecisionFloat(Enable.l)
  Protected FloatUnitControlWord.w
  !FSTCW [p.v_FloatUnitControlWord] ;Get current control word.
  ;Pretty much any PB command overwrites AX, this includes SELECT, IF, etc.
  Select Enable
    Case 0
      !MOV word AX,[p.v_FloatUnitControlWord]
      !AND AX,1111110011111111b ;Reset precision bits.
      ;!OR AX,0000001100000000b ;11 is the highest precision.
      !OR AX,0000001000000000b ;10 is the default precision under Windows.
      !MOV word [p.v_FloatUnitControlWord],AX
    Case 1
      !MOV word AX,[p.v_FloatUnitControlWord]
      !AND AX,1111110011111111b ;00 is the lowest precision.
      !MOV word [p.v_FloatUnitControlWord],AX
  EndSelect
  !FLDCW [p.v_FloatUnitControlWord] ;Write back the changed control word.
EndProcedure


CompilerIf #PB_Compiler_IsMainFile
  a.i
  d.f
  g.f
  CurrentTime.i
  Time1.i
  Time2.i
  
  ;SinglePrecisionFloat(0)
  CurrentTime = ElapsedMilliseconds()
  For a = 0 To 10000000
    d = 0.2*a
    d/2
    g = 0.3
    g*5
    d+g
    d/1.73
  Next
  Time1 = ElapsedMilliseconds()-CurrentTime
  MessageRequester(Str(Time1), StrF(d, 99))
  
  
  SinglePrecisionFloat(1)
  CurrentTime = ElapsedMilliseconds()
  For a = 0 To 10000000
    d = 0.2*a
    d/2
    g = 0.3
    g*5
    d+g
    d/1.73
  Next
  Time2 = ElapsedMilliseconds()-CurrentTime
  MessageRequester(Str(Time2), StrF(d, 99))
  
  MessageRequester("", StrF(Time2/Time1, 99))
CompilerEndIf
; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 12
; FirstLine = 5
; Folding = -
; DisableDebugger